#Simulation study (frequentist) of two estimators
#2014 June 28
nu=200
pi1=0.3
pi2=0.3
repet=100000
C1=rbinom(repet,nu,pi1)
M2=rbinom(repet,C1,pi2)
C2=M2+rbinom(repet,nu-C1,pi2)
Nchap=C1*C2/M2
Nchap2=C1*C1/M2
Nchap3=(C1+1)*(C2+1)/(M2+1)-1
windows()
par(mfrow=c(1,2))
hist(Nchap, nc=50,main="Lincoln-Petersen", xlab=paste("population size=",nu),
     xlim=c(0,500),freq=F,ylim=c(0,0.02), 
     sub=paste("mean=",round(mean(Nchap,na.rm=T)),"Std=",round(var(Nchap,na.rm=T)^0.5)))
hist(Nchap3,nc=50,main="Schnabel-Chapman", xlab=paste("population size=",nu),
     xlim=c(0,500),freq=F,ylim=c(0,0.02), 
     sub=paste("mean=",round(mean(Nchap3,na.rm=T)),"Std=",round(var(Nchap3,na.rm=T)^0.5)))
par(mfrow=c(1,1))
VSchnab=((C1+1)*(C2+1)*(C1-M2)*(C2-M2)/((M2+1)*(M2+1)*(M2+2)))
plot(seq(1,repet,by=100),VSchnab[seq(1,repet,by=100)]^0.5,typ="l", xlab="Some repetitions",ylab="Standard deviation of the Schnabel estimate")
lines(seq(1,repet,by=100),0*seq(1,repet,by=100)+var(Nchap3,na.rm=T)^0.5,col='red')
